#include <stdio.h>
#include <stdlib.h>
#include "integrate.h"

double sum(double start, double step, int first, int end, double (* funct)(double, void *), void *param){
	double result = 0.0;
	double x = start;
	int i;

	for (i = first; i < (end + 1); i++) {
		result +=  funct(x, param);
		x += step;
	}

	return result;

}

double simpson( double a, double b, double (* funct)(double, void *), void *param, int steps) {
	double result = 0.0,
		   dh = (b - a)/2.0/steps; //N = 2 * steps
	
	result = funct(a, param);
	result += funct(b, param);
	result += 2*(sum(a + 2*dh, 2*dh, 1, steps - 1, funct, param) + 
			  2*sum(a + dh, 2*dh, 1, steps, funct, param));
	result = result*dh/3.0;

	return result;
}

double trapezium( double a, double b, double (* funct)(double, void *), void *param, int steps) {
	double result = 0.0,
		   dh = (b - a)/steps*1.0;

	result = (funct(a, param) +  funct(b, param))/2.0;
	result += sum(a + dh, dh, 1, steps - 1, funct, param);
	result = result*dh;

	return result;
}