#ifndef TYPES_HEADER
    #define TYPES_HEADER 

typedef struct{
    double px;    
    double py;    
    double pz;
    double x;
    double y;
    double z;
    double time;
} particle_t;

typedef struct{
    double x;
    double y;
    double z;
} vect_t;

// typedef struct{
//     double Ex;
//     double Ey;
//     double Ez;
//     double Bx;
//     double By;
//     double Bz;
//     double iEx;
//     double iEy;
//     double iEz;
// } emf_t;

typedef struct{
    double Ex;
    double Ey;
    double Ez;
    // double Bx;
    // double By;
    // double Bz;
    double iEx;
    double iEy;
    double iEz;
} emf_t;



typedef struct{
    double px;
    double py;
    double pz;
    double x;
    double y;
    double z;
} Force_t;


typedef struct{
    //workparameters
    int steps;
    double dt;
    int scheme;
    int record;

    //EM field mode
    // int mode;
    // int q;
    int time_form;
    int space_form;

    //wave parameters
    double a0;
    double tau;
    double zf;
    double fi0;
    // double e0;
    double fnumber;
    
  	//mirror
    double ro0;
  	double phigr;

} config_t;

typedef struct {
    double x;
    double y; 
    double z; 
    double t; 
    double a0;
    double e0;
    double fi0;
    double tau;
    double fnumber;
} params_set;

#endif