#include "my_types.h"

#ifndef CALC_HEADER
    #define CALC_HEADER

#define GAMMA(x,y,z) sqrt(1 + (x)*(x) + (y)*(y) + (z)*(z))

// double force(int mode, emf_t f, double px, double py, double pz, double x, double y, double z);
Force_t make_force(void (*field_definition)(vect_t, double, emf_t*, config_t),
		 particle_t p, config_t cfg); 
// double Gamma(double px, double py, double pz);

void Runge_Kutta(Force_t *F,particle_t* el,  config_t cfg,
	void (*field_definition)(vect_t, double, emf_t*, config_t));
// void Adams_time_control(Force_t *F,particle_t* el, config_t cfg,
// 	void (*field_definition)(double, double, double, double,emf_t*, config_t));
void Adams(Force_t *F,particle_t* el, config_t cfg,
	void (*field_definition)(vect_t, double, emf_t*, config_t));
// void Boris(Force_t *F,particle_t* el, config_t cfg,
// 	void (*field_definition)(double, double, double, double,emf_t*, config_t));
    
// void acceleration_calculate(Force_t *F,vect_t* w, particle_t* p, config_t cfg,
// 	void (*field_definition)(double, double, double, double,emf_t*, config_t));
void (*initialize_method(int calc_scheme,int rank))(Force_t *F,particle_t* el, config_t cfg,
						  void (*field)(vect_t, double, emf_t*, config_t));
	
#endif